﻿// AddCyclicSeriesOfMAsterPages.jsx
#target indesign
#targetengine "AddMasterPages"
//////////////////
myProgramTitul = "Циклическая последовательность мастер-страниц (02.10.2012)" 
function main()  { // main
if(app.documents.length == 0) {
    alert("Нет открытых документов.", myProgramTitul);	
    exit();    
    }    
var mySelection = app.selection[0];
var myDoc = app.documents.item(0);
if (myDoc.masterSpreads.length == 1) { 
        alert ("Нет необходимости запускать этот скрипт, когда в работе только одна мастер-страница.", myProgramTitul); exit(); 
    }
var myCounter;
var myMasterArray = new Array;
var myWin = getDialog(myDoc,myMasterArray,myProgramTitul);
myWin.center();
myWin.show();
myDoc.textPreferences.smartTextReflow = false; // добавление страниц не должно быть причиной, что текст сразу сам растечется по страницам.
// в большинстве случаев это чередование макетов предполагает, что после появления нужного числа страниц инициировать вручную по каким страницам должен пройти поток текста
myCounter = myMasterArray[myMasterArray.length-1];
var myFirstPage = myDoc.pages.length;
for (var ii = 0; ii < myCounter; ii++) { // ii
    for (var jj = 0; jj < myMasterArray.length-1; jj++) { // jj   // .length-1 - исключаем из рассмотрения сохраненнное в этом массиве число повторений выбранных мастер-страниц
        myDoc.pages.add();
        myDoc.pages[-1].appliedMaster = myCurrentMaster(myDoc,myMasterArray[jj]);
    } // jj 
} // ii
try { myDoc.pages[myFirstPage].select(); // переходим на первую добавленную страницу
         var mySelection = app.selection[0];
        }
catch(e) { } 
} // main
////////////////////////////////////////////////////////////////////////////////////////////////////////////
function myCurrentMaster(myDoc,masterName) { //  myCurrentMaster
for (var k = 0; k < myDoc.masterSpreads.length; k++) { // k
if ( myDoc.masterSpreads[k].name != String(masterName)) continue;
else break;
} // k    
if (k == myDoc.masterSpreads.length) { 
    alert ("Не найден один из выбранных мастеров страницы (" + masterName +")"); exit(); 
    }
return myDoc.masterSpreads[k];    
 } //  myCurrentMaster    
//////////////////////////////////////////////////////////////////////////////////////////////////////////
getDialog = function(myDoc,myMasterArray) { // getDialog
// Создаем окно
var myWin = new Window( "dialog", myProgramTitul);
myWin.orientation = "column";
myPanels = myWin.add("panel");
myPanels.orientation = "column";
myPanels.alignChildren = "left";
myPrompt = myPanels.add("statictext", undefined, "Задать в правом окне очерёдность мастер-страниц");
myPrompt.alignChildren = "left";
// Добавляем панель
PanelSize = [0, 0, 200, 200];
Pnl = myPanels.add("group");
Pnl.orientation = "row";
// —Добавляем первый список в панель
Pnl.listBox1 = Pnl.add( "listbox", PanelSize );
Pnl.listBox1.helpTip = "Двойной щелчок на строке скопирует её в правое окно"
var itemslistBox1= new Array;
for (var j=0; j < myDoc.masterSpreads.length; j++) {
		itemslistBox1[j] =Pnl.listBox1.add( "item", myDoc.masterSpreads[j].name);
}
// Добавляем в панель второй список
Pnl.listBox2 = Pnl.add( "listbox", PanelSize);
Pnl.listBox2.helpTip = "Двойной щелчок на строке удалит её"
var itemslistBox2 = new Array;
///
Pnl.listBox1.addEventListener ("click", function (event) {
    var sel1 = Pnl.listBox1.selection;
    if(sel1 != null) {
        Pnl.listBox2.add("item", sel1);
        Pnl.listBox1.selection = null; // снимаем выделение с перенесенного в правое окно мастера
       SetButtonState(okButton);
    }    
});
///
Pnl.listBox2.addEventListener ("click", function (event) {
    var sel2 = Pnl.listBox2.selection;
    if(sel2 != null) {
        Pnl.listBox2.remove(sel2);
        SetButtonState(okButton);
    }    
});
///
MastInfo = myPanels.add("group", undefined);
MastInfo.orientation = "row";
//Info = MastInfo.add("statictext", [0, 0, 305,15], "Сколько  групп выбранных мастер-страниц добавить"); страницы с циклическим применением мастеров //   \u00A0\u00A0
Info = MastInfo.add("statictext", [0, 0, 360,15], " \u00A0Число групп страниц с циклическим применением мастеров"); 
myNumber = MastInfo.add("edittext", [0, 0, 40, 25] , 1);
///
myNumber.onChange = function () { // myNumber.onChange()
myCounter = Number(myNumber.text); 
if (isNaN(myCounter) == true || myCounter <= 0 || parseInt(myCounter) != myCounter ) { okButton.enabled = false; myNumber.text = "???"; return; }   
if (Pnl.listBox2.items.length != 0) okButton.enabled = true;
} // myNumber.onChange()
///
var myBtnAndCopiRightInfo = myWin.add( "group" );
myBtnAndCopiRightInfo.alignChildren = ["fill", "fill"];
myEmptySpace = [0,0,45,20];
myBtnAndCopiRightInfo.alignChildren = "right";
var okButton = myBtnAndCopiRightInfo.add( "button", undefined, "OK" );
okButton.helpTip = "Страницы добавляются в конец документа.\nПосле добавления будет выбрана первая добавленная страница."
okButton.enabled = false;
okButton.onClick = function() { // okButton.onClick
myCounter = Number(myNumber.text); 
for (var j = 0; j < Pnl.listBox2.items.length; j++) { myMasterArray [j] = Pnl.listBox2.items[j] }
myMasterArray [j] = myCounter;
this.window.close(1);
}// okButton.onClick
myBtnAndCopiRightInfo.add("statictext", myEmptySpace,"");
CopyRightInfo = myBtnAndCopiRightInfo.add("statictext", [0,0,145,20],"© adobeindesign.ru, 2012");
myBtnAndCopiRightInfo.add("statictext", myEmptySpace,"");
myWin.canButton = myBtnAndCopiRightInfo.add( "button", undefined, "Cancel" );
myWin.canButton.onClick = function() { // canButton.onClick
this.window.close(2);
} // canButton.onClick
return myWin;
} // getDialog
////////////////////////
function SetButtonState(okButton) { //  SetButtonState()
myCounter = Number(myNumber.text); 
if (isNaN(myCounter) == true || myCounter <= 0 || parseInt(myCounter) != myCounter) { okButton.enabled = false; return; }
if (Pnl.listBox2.items.length == 0) okButton.enabled = false;
else okButton.enabled = true;
} //  SetButtonState()

main();